SystemOrganization addCategory: #Proxies!

!CompiledMethod methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/17/2010 21:58'!
mareaPrintString 
	^ self methodClass asString, '>>', self selector.! !

ProtoObject subclass: #ClassProxyInstVar
	instanceVariableNames: 'superclass methodDict format actualClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ClassProxyInstVar methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:04'!
doesNotUnderstand: aMessage
	self restore. 
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ClassProxyInstVar methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 10/1/2010 14:57'!
initialize
	super initialize.
	superclass := ProxySuperclass.
	methodDict := nil.
	actualClass := self! !

!ClassProxyInstVar methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/22/2010 17:23'!
restore
	self mareaLog: 'Will restore class'.
	self become: actualClass.
	self mareaLog: 'Class restored'.
! !

ProtoObject subclass: #CompiledMethodProxy
	instanceVariableNames: 'oldMethod reference executed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 16:18'!
installOn: aClass selector: aSel
	| newInst |
	newInst := (self on: aClass selector: aSel)  mareaInstall.
	^ newInst! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
installOnClass: aClass
	|someWrappers|
	someWrappers:=OrderedCollection new.
	aClass selectors do: [:aSymbol | someWrappers add: (self installOn: aClass selector: aSymbol)].
	aClass class selectors do: [:aSymbol | someWrappers add: (self installOn: aClass class selector: aSymbol)].
	^someWrappers! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
installOnClassCategory: aString
	|someWrappers|
	someWrappers:= OrderedCollection new.
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		someWrappers addAll: (self installOnClass: (Smalltalk classNamed: aClassName)).
		].
	^someWrappers
	! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
on: aMethodReference
	^self new initializeFor: aMethodReference ! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 16:12'!
uninstallClass: aClass
	aClass methodDict values do: [:e | (e isKindOf: self) ifTrue: [e mareaUninstall]].
	aClass class methodDict values do: [:e | (e isKindOf: self) ifTrue: [e mareaUninstall]].! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
uninstallClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
uninstallOnClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!CompiledMethodProxy methodsFor: 'testing' stamp: 'MarianoMartinezPeck 10/22/2010 17:23'!
doesNotUnderstand: aMessage
	self mareaLog: ' CompiledMethodProxy dnu: ', aMessage asString.
	^ oldMethod isNil
		ifTrue: [
			"It was not installed"
			super doesNotUnderstand: aMessage]
		ifFalse: [
			"It was installed, thus, I should uninstall it"
			self mareaUninstall.
			oldMethod perform: aMessage selector withArguments: aMessage arguments.
			]! !

!CompiledMethodProxy methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/19/2010 11:44'!
flushCache
	"This method should be implemented because otherwise there are errors."! !

!CompiledMethodProxy methodsFor: 'initializing' stamp: 'MarianoMartinezPeck 10/18/2010 10:53'!
initialize

	super initialize.
	executed := false! !

!CompiledMethodProxy methodsFor: 'initializing' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
initializeFor: aMethodReference 
	reference := aMethodReference.! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 16:20'!
mareaExecuted
	^ executed! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 16:20'!
mareaExecuted: anObject
	executed := anObject! !

!CompiledMethodProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 10/22/2010 17:23'!
mareaInstall
	[oldMethod := self mareaWrappedClass lookupSelector: self mareaSelector.
	oldMethod isKindOf: self class] whileTrue: [oldMethod mareaUninstall].
	"self wrappedClass addSelector: self selector withMethod: self" 
	self mareaLog: 'The method ', self mareaSelector asString, ' is being wrapped'.
	self mareaWrappedClass methodDict at: self mareaSelector put: self! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 16:20'!
mareaOldMethod
	"Answer the value of oldMethod"

	^ oldMethod! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 16:20'!
mareaOldMethod: anObject
	"Set the value of oldMethod"

	oldMethod := anObject! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 16:21'!
mareaReference
	^ reference ! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 17:02'!
mareaSelector
	"Answer the value of selector"

	^ reference selector! !

!CompiledMethodProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 10/22/2010 17:14'!
mareaUninstall
	oldMethod isNil ifTrue: [^self].
	self mareaWrappedClass methodDict at: self mareaSelector put: oldMethod  

! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 16:22'!
mareaWrappedClass
	"Answer the value of wrappedClass"

	^ reference actualClass! !

!CompiledMethodProxy methodsFor: 'evaluation' stamp: 'MarianoMartinezPeck 10/22/2010 17:23'!
run: aSelector with: arguments in: aReceiver

	| aResult |
	self mareaLog: 'The method ', aSelector asString, ' is being executed'.
	aResult := oldMethod valueWithReceiver: aReceiver arguments: arguments.
	self mareaExecuted: true.
	self mareaLog: 'The method', aSelector asString, ' was executed'.
	self mareaUninstall.
	self mareaLog: 'The method proxy was uninstalled'.
	^aResult
	! !

ProtoObject subclass: #ObjectProxy
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 15:39'!
aTest

| o p |
o := MyClass new.
o foo: 123.
p := ClassProxy3 new.
p become: MyClass.
MyClass flushCache.
ClassProxy3 flushCache.
o == nil.
Transcript show: o class name; cr.
o foo.
! !

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 16:51'!
forFileName: aFileName
	^ self new fileName: aFileName ! !

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/20/2010 17:29'!
initialize
	"With this, The compiler does not associate #class with a special bytecode. Then, we can use #class like a normal message. So we can for example, override its behavior."
	(ParseNode classVarNamed:  'StdSelectors') removeKey: #class ifAbsent: [].! !

!ObjectProxy methodsFor: 'proxy' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
become: anObject
	self mareaSerializeAndWriteToDisk: anObject.
	"anObject becomeForward: self. "
	super become: anObject. ! !

!ObjectProxy methodsFor: 'catching' stamp: 'MarianoMartinezPeck 10/22/2010 17:23'!
doesNotUnderstand: aMessage
	self mareaLog: 'Message not understood:', aMessage asString.
	self mareaLog: 'Will restore object'.
	self become: self mareaLoadBackSerializedObjectsFromFile.
	self mareaLog: 'Object was restored'.
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ObjectProxy methodsFor: 'swapping' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
mareaLoadBackSerializedObjectsFromFile

	| file result |
	file := FileStream fileNamed: fileName.
	file binary.
	result := (ReferenceStream on: file) next.
	file close.
	^ result! !

!ObjectProxy methodsFor: 'swapping' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
mareaSerializeAndWriteToDisk: anObject	
	| file result |
	fileName := (DateAndTime now asString, '.swap').
	file := FileStream fileNamed: fileName.
	file binary.
	(ReferenceStream on: file) nextPut: anObject.
	file close.! !

!ProtoObject methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 10/20/2010 11:33'!
class
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!ProtoObject methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/17/2010 19:53'!
mareaClass
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 19:01'!
mareaAt: key 
	"Answer the value associated with the key."

	^ self mareaAt: key ifAbsent: [self errorKeyNotFound]! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 19:00'!
mareaAt: key ifAbsent: aBlock

	| index |
	index := self findElementOrNil: key.
	(self basicAt: index) == nil ifTrue: [ ^ aBlock value ].
	^ array at: index! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 17:43'!
initialize 
	CurrentNumber := 0.! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 17:44'!
installOn: aClass selector: aSel
	^ (self on: aClass selector: aSel)! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 17:44'!
mareaNextNumber
	CurrentNumber := CurrentNumber + 1.
	^ CurrentNumber! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 18:28'!
on: aMethodReference
	^self mareaNextNumber mareaInstallFor: aMethodReference 
	! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 17:44'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 17:50'!
doesNotUnderstand: aMessage
	| oldMethod answer |
	self mareaLog: 'CompiledMethodProxyReferenceStream dnu: ', aMessage selector.
	oldMethod := self mareaUninstall.
	self mareaLog: 'The message will be sent to the original object'.
	answer := oldMethod perform: aMessage selector withArguments: aMessage arguments.
	self mareaLog: 'The message was sent to the original object'.
	^ answer.
! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 22:58'!
flushCache
	"I cannot do anything here because otherwise it crash the VM"! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 17:57'!
fooSomething
	^ 'fooSomethingProxy'! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 23:55'!
mareaFileName
	^ self asString, '.swap'! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 22:51'!
mareaInstallFor: aMethodReference
	| oldMethod oldClass selector |
	oldClass := aMethodReference actualClass. 
	selector := aMethodReference  selector. 
	[oldMethod := oldClass lookupSelector: selector.
	oldMethod isKindOf: self class] whileTrue: [oldMethod mareaUninstall].
	"self wrappedClass addSelector: self selector withMethod: self" 
	self mareaLog: 'The method ', selector asString, ' is being wrapped with SmallIngeger: ', self asString.
	self mareaWriteMethodOnDisk: oldMethod.
	oldClass methodDict at: selector put: self.
	! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 23:55'!
mareaLoadCompiledMethod
	| refStream aCompiledMethod |
	refStream := ReferenceStream fileNamed: self mareaFileName.
	aCompiledMethod := refStream next.
	refStream close.
	^ aCompiledMethod! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 22:56'!
mareaUninstall
	| oldMethod |
	oldMethod := self mareaLoadCompiledMethod.
	self mareaLog: 'The CompiledMethod ', oldMethod selector, ' was loaded form file.'.
	oldMethod methodClass  methodDict at: (oldMethod selector) put: oldMethod.
	self mareaLog: 'The Proxy for ', oldMethod selector, ' was uninstalled.'.
	^ oldMethod.  

! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 18:30'!
mareaUninstallForClass: aClass selector: aSelector
	"I implement this just for compatibility with other CompiledMethodProxies"
	self mareaUninstall! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 23:55'!
mareaWriteMethodOnDisk: aCompiledMethod
	| refStream | 
	refStream := ReferenceStream fileNamed: self mareaFileName.
	refStream nextPut: aCompiledMethod.
	refStream close.
	self mareaLog: 'The method ', aCompiledMethod selector asString, ' was written on file named: ', self asString..

! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 17:57'!
run: aSelector with: arguments in: aReceiver

	| aResult oldMethod |
	self mareaLog: 'The method ', aSelector, ' is being executed'.
	oldMethod := self mareaUninstall.
	aResult := oldMethod valueWithReceiver: aReceiver arguments: arguments.
	self mareaLog: 'The method ', aSelector, ' was executed'.
	^aResult
	! !

Object subclass: #ClassProxyFileOut
	instanceVariableNames: 'superclass methodDict format className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/17/2010 17:02'!
become: aClass
	| classNameBkp |
	className := aClass name.
	"FileDirectory default  deleteFileNamed: aClass name, '.st'  ifAbsent: [].
	"aClass fileOut.
	"Smalltalk removeClassNamed: className.
	"
	super become: aClass
! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:49'!
doesNotUnderstand: aMessage
	self restore. 
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:52'!
fileInClass.
	(FileStream fileNamed: className, '.st') fileIn.
	^ Smalltalk at: className. 
	! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:50'!
initialize
	super initialize.
	superclass := ProxySuperclass.
	methodDict := nil.
! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/22/2010 17:23'!
restore
	self mareaLog: 'Will restore class'.
	super become: self fileInClass.
	self mareaLog: 'Class restored'.
! !

Object subclass: #CompiledMethodProxyReferenceStreamWithFileName
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!CompiledMethodProxyReferenceStreamWithFileName classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/28/2010 00:01'!
installOn: aClass selector: aSel
	^ (self on: aClass selector: aSel)! !

!CompiledMethodProxyReferenceStreamWithFileName classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/28/2010 00:01'!
installOnClass: aClass
	|someWrappers|
	someWrappers:=OrderedCollection new.
	aClass selectors do: [:aSymbol | someWrappers add: (self installOn: aClass selector: aSymbol)].
	aClass class selectors do: [:aSymbol | someWrappers add: (self installOn: aClass class selector: aSymbol)].
	^someWrappers! !

!CompiledMethodProxyReferenceStreamWithFileName classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/28/2010 00:01'!
installOnClassCategory: aString
	|someWrappers|
	someWrappers:= OrderedCollection new.
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		someWrappers addAll: (self installOnClass: (Smalltalk classNamed: aClassName)).
		].
	^someWrappers
	! !

!CompiledMethodProxyReferenceStreamWithFileName classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/28/2010 00:01'!
on: aMethodReference
	^self new mareaInstallFor: aMethodReference ! !

!CompiledMethodProxyReferenceStreamWithFileName classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/28/2010 00:01'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!CompiledMethodProxyReferenceStreamWithFileName classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/28/2010 00:01'!
uninstallClass: aClass
	aClass methodDict values do: [:e | (e isKindOf: self) ifTrue: [e mareaUninstall]].
	aClass class methodDict values do: [:e | (e isKindOf: self) ifTrue: [e mareaUninstall]].! !

!CompiledMethodProxyReferenceStreamWithFileName classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/28/2010 00:01'!
uninstallClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!CompiledMethodProxyReferenceStreamWithFileName classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/28/2010 00:01'!
uninstallOnClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!CompiledMethodProxyReferenceStreamWithFileName methodsFor: 'catching' stamp: 'MarianoMartinezPeck 11/21/2010 19:12'!
doesNotUnderstand: aMessage
	| oldMethod answer |
	self mareaLog: 'CompiledMethodProxyReferenceStream dnu: ', aMessage selector.
	oldMethod := self mareaUninstall.
	self mareaLog: 'The message will be sent to the original object'.
	answer := oldMethod perform: aMessage selector withArguments: aMessage arguments.
	self mareaLog: 'The message was sent to the original object'.
	^ answer.
! !

!CompiledMethodProxyReferenceStreamWithFileName methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/28/2010 00:01'!
flushCache
	"Tell the interpreter to remove all references to this method from its method lookup cache, if it has one.  This primitive must be called whenever a method is defined or removed.
	NOTE:  Only one of two selective flush methods needs to be used.
	Squeak 2.2 and earlier uses 119 (See Symbol flushCache).
	Squeak 2.3 and later uses 116 (See CompiledMethod flushCache)."

	<primitive: 116>
! !

!CompiledMethodProxyReferenceStreamWithFileName methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 10/28/2010 00:20'!
mareaFileNameFromClass: aClass selector: aSelector.
	^  aClass asString, '>>', aSelector.! !

!CompiledMethodProxyReferenceStreamWithFileName methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 11/21/2010 19:12'!
mareaInstallFor: aMethodReference
	| oldMethod oldClass selector |
	oldClass := aMethodReference actualClass. 
	selector := aMethodReference  selector. 
	[oldMethod := oldClass lookupSelector: selector.
	oldMethod isKindOf: self class] whileTrue: [oldMethod mareaUninstall.].
	"self wrappedClass addSelector: self selector withMethod: self" 
	self mareaLog: 'The method ', selector asString, ' is being wrapped'.
	self mareaWriteMethodOnDisk: oldMethod.
	oldClass methodDict at: selector put: self.
	! !

!CompiledMethodProxyReferenceStreamWithFileName methodsFor: 'swapping' stamp: 'MarianoMartinezPeck 11/21/2010 19:07'!
mareaLoadCompiledMethodFrom
	| refStream aCompiledMethod |
	refStream := ReferenceStream fileNamed: fileName.
	aCompiledMethod := refStream next.
	refStream close.
	^ aCompiledMethod! !

!CompiledMethodProxyReferenceStreamWithFileName methodsFor: 'evaluation' stamp: 'MarianoMartinezPeck 11/21/2010 19:10'!
mareaUninstall
	| oldMethod |
	oldMethod := self mareaLoadCompiledMethodFrom.
	self mareaLog: 'The CompiledMethod ', oldMethod selector, ' was loaded form file.'.
	oldMethod methodClass  methodDict at: (oldMethod selector) put: oldMethod.
	self mareaLog: 'The Proxy for ', oldMethod selector, ' was uninstalled.'.
	^ oldMethod.  
! !

!CompiledMethodProxyReferenceStreamWithFileName methodsFor: 'swapping' stamp: 'MarianoMartinezPeck 11/22/2010 15:16'!
mareaWriteMethodOnDisk: aCompiledMethod
	| refStream | 
	fileName := aCompiledMethod mareaPrintString, '.swap'..
	(FileDirectory default isAFileNamed: fileName)
		ifTrue: [fileName := aCompiledMethod mareaPrintString, '_.swap'.].
	refStream := ReferenceStream fileNamed: fileName.
	refStream nextPut: aCompiledMethod.
	refStream close.
	self mareaLog: 'The method ', aCompiledMethod selector asString, ' was written on file'.

! !

!CompiledMethodProxyReferenceStreamWithFileName methodsFor: 'evaluation' stamp: 'MarianoMartinezPeck 11/21/2010 19:12'!
run: aSelector with: arguments in: aReceiver

	| aResult oldMethod |
	self mareaLog: 'The method ', aSelector, ' is being executed'.
	oldMethod := self mareaUninstall.
	aResult := oldMethod valueWithReceiver: aReceiver arguments: arguments.
	self mareaLog: 'The method ', aSelector, ' was executed'.
	^aResult
	! !

Object subclass: #CompiledMethodSwapper
	instanceVariableNames: ''
	classVariableNames: 'ProxyClass'
	poolDictionaries: ''
	category: 'Proxies'!

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 16:27'!
discoverMinimalUsedCompiledMethods
"These the minimal CompiledMethods needed to install and install a CompiledMethodProxy"
	| aProxy |
	
	UnusedObjectDiscoverer current startDiscovery. 
	
	aProxy := self installOn: ClassWith1Var selector: #foo.
	(ClassWith1Var methodDict at: #foo) literals.
	aProxy mareaUninstall.
	
	aProxy := self installOn: ClassWith1Var selector: #foo.
	ClassWith1Var new foo.
	aProxy mareaUninstall.
	
	UnusedObjectDiscoverer current stopDiscovery.
	^ CompiledMethod usedInstances.! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 19:02'!
initialize
	self proxyClass: CompiledMethodProxyReferenceStreamWithFileName.! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 16:27'!
installOn: aClass selector:  aSelector.
	^ self proxyClass installOn: aClass selector: aSelector.! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfCorePackages
	^ self listOfCorePackagesNames collect: [:each |  PackageInfo named: each ]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfCorePackagesNames
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"

	^  #('MultilingualTests' 'Morphic' 'ToolBuilder-Kernel' 'PackageInfo' 'Polymorph-ToolBuilder' 'Network-Kernel' 'Network-Protocols' 'Compiler' 'System-Finalization' 'Settings-Graphics' 'Collections' 'Network-RemoteDirectory' 'Traits' 'Network-URI' 'Settings-Display' 'Collections-Abstract' 'Settings-Compiler' 'MonticelloMocks' 'ScriptLoader11' 'System-Digital Signatures' 'System-Localization' 'MenuRegistration' 'Polymorph-TaskbarIcons' 'Monticello' 'ToolBuilder-Morphic' 'MCDirtyPackage' 'Collections-Weak' 'Settings-Polymorph' 'Tests' 'HelpSystem-Core-Utilities' 'SUnit' 'Collections-Text' 'Compression' 'Morphic-MorphTreeWidget' 'HelpSystem-Core' 'ToolsTest' 'Gofer-Core' 'Gofer-Tests' 'Collections-Stack' 'FreeType' 'MonticelloConfigurations' 'Polymorph-Geometry' 'Collections-Support' 'SUnitGUI' 'HelpSystem-Core-Model' 'Tests-VM' 'System-Change Notification' 'System' 'Tests-ObjectsAsMethods' 'HostMenus' 'Network-MIME' 'Network-RFC822' 'VB-Regex' 'TrueType' 'DeprecatedPreferences' 'System-Clipboard' 'System-Settings' 'MorphicTests' 'System-Serial Port' 'NetworkTests' 'Collections-Unordered' 'System-Changes' 'System-Object Storage' 'Collections-Traits' 'System-Platforms' 'Tests-PrimCallController' 'Morphic-TrueType' 'Multilingual' 'Graphics' 'Collections-Strings' 'KernelTests' 'System-FileRegistry' 'Tests-Bugs' 'ToolBuilder-SUnit' 'Tests-Release' 'Morphic-Balloon' 'Settings-Network' 'System-Applications' 'Polymorph-Tools-Diff' 'Settings-Tools' 'ScriptLoader' 'ST80' 'FreeTypeSubPixelAntiAliasing' 'Settings-Kernel' 'Settings-System' 'CompilerTests' 'System-Tools' 'System-Hashing' 'System-Download' 'Collections-Streams' 'Tests-SystemChangeNotification' 'GraphicsTests' 'Polymorph-Widgets' 'Kernel' 'Tools' 'Settings-FreeType' 'FreeTypeTests' 'Settings-Monticello' 'HelpSystem-Tests' 'Polymorph-EventEnhancements' 'System-Support' 'MonticelloGUI' 'System-FilePackage' 'System-Object Events' 'Announcements' 'System-Text' 'Exceptions' 'Network-UUID' 'System-Pools' 'FixUnderscores' 'HelpSystem-Core-UI' 'GraphicsResources' 'Files' 'Gofer' 'Network-MailSending' 'Collections-Arrayed' 'CollectionsTests' 'Balloon' 'Network-Url' 'Collections-Sequenceable')! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfNotDangerousCorePackages
	^ self listOfNotDangerousCorePackagesNames collect: [:each |  PackageInfo named: each ]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 19:01'!
listOfNotDangerousCorePackagesNames
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"

	^  #('MultilingualTests' 'Morphic' 'ToolBuilder-Kernel' 'PackageInfo' 'Polymorph-ToolBuilder' 'Network-Kernel' 'Network-Protocols' 'Compiler' 'System-Finalization' 'Settings-Graphics' 'Collections' 'Network-RemoteDirectory' 'Traits' 'Network-URI' 'Settings-Display' 'Collections-Abstract' 'Settings-Compiler' 'MonticelloMocks' 'ScriptLoader11' 'System-Digital Signatures' 'System-Localization' 'MenuRegistration' 'Polymorph-TaskbarIcons' 'Monticello' 'ToolBuilder-Morphic' 'MCDirtyPackage' 'Collections-Weak' 'Settings-Polymorph' 'Tests' 'HelpSystem-Core-Utilities' 'SUnit' 'Collections-Text' 'Compression' 'Morphic-MorphTreeWidget' 'HelpSystem-Core' 'ToolsTest' 'Gofer-Core' 'Gofer-Tests' 'Collections-Stack' 'FreeType' 'MonticelloConfigurations' 'Polymorph-Geometry' 'Collections-Support' 'SUnitGUI' 'HelpSystem-Core-Model' 'Tests-VM' 'System-Change Notification' 'System' 'Tests-ObjectsAsMethods' 'HostMenus' 'Network-MIME' 'Network-RFC822' 'VB-Regex' 'TrueType' 'DeprecatedPreferences' 'System-Clipboard' 'System-Settings' 'MorphicTests' 'System-Serial Port' 'NetworkTests' 'Collections-Unordered' 'System-Changes' 'System-Object Storage' 'Collections-Traits' 'System-Platforms' 'Tests-PrimCallController' 'Morphic-TrueType' 'Multilingual' 'Graphics' 'Collections-Strings' 'KernelTests' 'System-FileRegistry' 'Tests-Bugs' 'ToolBuilder-SUnit' 'Tests-Release' 'Morphic-Balloon' 'Settings-Network' 'System-Applications' 'Polymorph-Tools-Diff' 'Settings-Tools' 'ScriptLoader' 'ST80' 'FreeTypeSubPixelAntiAliasing' 'Settings-Kernel' 'Settings-System' 'CompilerTests' 'System-Tools' 'System-Hashing' 'System-Download' 'Collections-Streams' 'Tests-SystemChangeNotification' 'GraphicsTests' 'Polymorph-Widgets' 'Kernel' 'Tools' 'Settings-FreeType' 'FreeTypeTests' 'Settings-Monticello' 'HelpSystem-Tests' 'Polymorph-EventEnhancements' 'System-Support' 'MonticelloGUI' 'System-FilePackage' 'System-Object Events' 'Announcements' 'System-Text' 'Exceptions' 'Network-UUID' 'System-Pools' 'FixUnderscores' 'HelpSystem-Core-UI' 'GraphicsResources' 'Files' 'Gofer' 'Network-MailSending' 'Collections-Arrayed' 'CollectionsTests' 'Balloon' 'Network-Url' 'Collections-Sequenceable') select: [:each| each includesSubString: 'Test' ]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/22/2010 15:16'!
nose 
	"self nose"
	| minimalCompiledMethods methodsToSwap timeToInstall |
	MareaLogger changeToFileLogger.
	3 timesRepeat: [Smalltalk garbageCollect].
	Transcript show: 'Using proxy class: ', self proxyClass name; cr.
	Transcript show: 'Proxy instances before start: ', self proxyClass instanceCount asString; cr.
	Transcript show: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString; cr.
	Transcript show: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString; cr.
	minimalCompiledMethods := self discoverMinimalUsedCompiledMethods.
 	methodsToSwap := OrderedCollection new.
"	self listOfNotDangerousCorePackages do: [:aPackage |
		aPackage classes do: [:aClass |"
			
			"methodsToSwap add: FalseTest >> #testOr.
			methodsToSwap add: FalseTest >> #testAnd.
			"
			methodsToSwap addAll: FalseTest methods.
			
			"]."
	"	]."
	methodsToSwap := (methodsToSwap difference: minimalCompiledMethods).
	Transcript show: 'CompiledMethods to swap: ',  methodsToSwap size asString; cr.

	timeToInstall := MessageTally time: [
	methodsToSwap do: [:method| self installOn: method methodClass selector: method selector.].
	].
	Transcript show: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'; cr.
	methodsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	Transcript show: 'Proxy instances after installing: ', self proxyClass instanceCount asString; cr.
	Transcript show: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString; cr.
	Transcript show: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString; cr.
	self proxyClass allInstances do: [:each | each mareaUninstall].
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	Transcript show: 'Proxy instances after uninstalling: ', self proxyClass instanceCount asString; cr.
	Transcript show: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString; cr.
	Transcript show: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString; cr.
	(FileDirectory default fileNamesMatching: '*.swap') 
	do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/19/2010 20:02'!
nose2 
	| minimalCompiledMethods |
	minimalCompiledMethods := self discoverMinimalUsedCompiledMethods.
	TestRunner methods do: [ :aMethod |
			CompiledMethodProxyReferenceStream installOn: TestRunner selector: aMethod selector.
			]. 
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 16:24'!
proxyClass
	^ ProxyClass! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 16:25'!
proxyClass: aProxyClass
	ProxyClass := aProxyClass.! !

Object subclass: #ObjectSwapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/21/2010 18:26'!
fileName
	^ DateAndTime now asString , '.swap'! !

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
mareaSerializeAndWriteToDisk: anObject
	| file fileName result |
	fileName := self fileName.
	file := FileStream fileNamed: fileName.
	file binary.
	(ReferenceStream on: file) nextPut: anObject.
	file close.
	^ fileName! !

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
swap: anObject
	| fileName proxy |
	fileName := self mareaSerializeAndWriteToDisk: anObject. 
	
	"make this nicer"
	anObject isBehavior 
		ifTrue: [proxy := AClassProxy forFileName: fileName.]
		ifFalse: [proxy := ObjectProxy forFileName: fileName.].
	
	anObject becomeForward: proxy. ! !

Object subclass: #ProxySuperclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ProxySuperclass methodsFor: 'swapping' stamp: 'NouryBouraqadi 10/1/2010 15:08'!
cannotInterpret: aMessage
	Transcript cr; 
		show: 'cannotInterpret:';
		space;
		show: aMessage selector..
	self class restore.
	^aMessage sendTo: self! !
SmallInteger initialize!
CompiledMethodSwapper initialize!
ObjectProxy initialize!
